Index: trunk/kernel/devices/dev_nic.c
===================================================================
--- trunk/kernel/devices/dev_nic.c	(revision 674)
+++ trunk/kernel/devices/dev_nic.c	(revision 683)
@@ -999,21 +1123,24 @@
                     dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
                 }
-                else        // received SYN without ACK => client becomes server
+                else        // SYN without ACK => TCP client becomes a TCP server
                 {
 
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] for socket[%x,%d] %s : received SYN-ACK => become server\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : received SYN without ACK => send a SYN_ACK\n",
+__FUNCTION__, pid, fdid , socket_state_str(socket_state) );
 #endif
                     // update socket.state
-                    hal_remote_s32( XPTR(socket_cxy,&socket_ptr->state), TCP_STATE_SYN_RCVD );
+                    hal_remote_s32( XPTR(socket_cxy,&socket_ptr->state),
+                                    TCP_STATE_SYN_RCVD );
 
                     // set socket.tx_nxt 
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_nxt), TCP_ISS_SERVER );
+                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_nxt),
+                                    CONFIG_SOCK_ISS_SERVER );
 
                     // set socket.rx_nxt to seg_seq_num + 1
                     hal_remote_s32( XPTR(socket_cxy,&socket_ptr->rx_nxt), seg_seq_num + 1 );
 
-                    // make a SYN.ACK request to R2T queue
+                    // send SYN.ACK to remote TCP
                     socket_put_r2t_request( socket_r2tq_xp,
                                             TCP_FLAG_SYN | TCP_FLAG_ACK,
@@ -1021,100 +1148,8 @@
                 }
                 break;
-            }
-            ////////////////////////
-            case TCP_STATE_SYN_RCVD:  // TCP server waiting last ACK in connect handshake 
-            {
-                // [1] check sequence number
-                if( seg_seq_num != socket_rx_nxt )        // unexpected SEQ_NUM => discard
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : expect seq_num %x / get %x\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state), socket_rx_nxt, seg_seq_num );
-#endif
-                    // discard segment without reporting
-                    break;
-                } 
-
-                // [2] handle RST flag                    // received RST => report error
-                if( seg_rst_set )
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received RST flag\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
-#endif
-                    // update socket state
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ), TCP_STATE_BOUND );
-
-                    // report error to local TX client thread
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_RST );
-
-                    break;
-                }
-
-                // [3] handle security & precedence TODO ... someday
-
-                // [4] handle SYN flag 
-                if( seg_syn_set )                           // received SYN => discard
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received SYN flag\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
-#endif
-                    // discard segment without reporting
-                    break;
-                } 
-
-                // [5] handle  ACK flag 
-                if( seg_ack_set == false )                      // missing ACK => discard
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : no ACK in TCP segment\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
-#endif
-                    // discard segment without reporting
-                    break;
-                }
-                else if( seg_ack_num != (TCP_ISS_SERVER + 1) )  // unacceptable ACK
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : expect ack_num %x / get %x\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, 
-socket_state_str(socket_state), TCP_ISS_SERVER + 1, seg_ack_num );
-#endif
-
-                    // register an RST request to R2TQ for remote TCP client 
-                    socket_put_r2t_request( socket_r2tq_xp,
-                                            TCP_FLAG_RST,
-                                            chdev->channel );
-
-                    // report error to local TX client thread
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADACK );
-                }
-                else                                           // acceptable ACK
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received expected ACK\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
-#endif
-                    // set socket.tx_una  
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_una), seg_ack_num );
-
-                    // update socket.state
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state), 
-                                    TCP_STATE_ESTAB );
-
-                    // report success to local TX client thread
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
-                }
-                break;
-            }
-            /////////////////////
+            }  // end state SYN_SENT
+
+            ////////////////////////    all "connected" states
+            case TCP_STATE_SYN_RCVD:
             case TCP_STATE_ESTAB:
             case TCP_STATE_FIN_WAIT1:
@@ -1125,168 +1160,353 @@
             case TCP_STATE_TIME_WAIT:
             {
-                // [1] check sequence number : out_of_order segments not accepted
-                if( seg_seq_num != socket_rx_nxt )
+                // [1] check SEQ_NUM 
+                // - we accept duplicate segments (i.e. seq_num < rx_next)
+                // - we don't accept out of order segment (i.e. seq_num_num > rx_next)
+                //   => seq_num must be in window [rx_nxt - rx_win , rx_nxt]
+
+                bool_t seq_ok =  is_in_window( seg_seq_num,
+                                               (socket_rx_nxt - socket_rx_wnd),
+                                               socket_rx_nxt );
+
+                if( seq_ok == false ) // SEQ_NUM not acceptable
                 {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : illegal SEQ_NUM %x / expected %x\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state), seg_seq_num, socket_rx_nxt );
-#endif
-                    // discard segment
-                    break;
-                } 
-
-                // check all bytes in window when the payload exist
-                // TODO : we could accept bytes that are in window, 
-                // but this implementation reject all bytes in segment 
-                if( seg_data_len > 0 )
-                {
-                    // compute min & max acceptable sequence numbers
-                    uint32_t seq_min  = socket_rx_nxt;
-                    uint32_t seq_max  = socket_rx_nxt + socket_rx_wnd - 1;
-
-                    // compute sequence number for last byte in segment 
-                    uint32_t seg_seq_last = seg_seq_num + seg_data_len - 1;
-                      
-                    if( is_in_window( seg_seq_last, seq_min, seq_max ) == false ) 
+                    if( seg_rst_set )
                     {
 
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : last SEQ_NUM %x not in [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state), seg_seq_last, seq_min, seq_max );
-#endif
-                        // discard segment
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s expect seq_num %x != rcvd %x and RST => discard\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state),
+CONFIG_SOCK_ISS_CLIENT + 1, seg_seq_num );
+#endif
                         break;
                     }
-                } 
-
-                // [2] handle RST flag
-                if( seg_rst_set )
+                    else  // no RST
+                    {
+                        // send ACK to remote TCP
+                        socket_put_r2t_request( socket_r2tq_xp,
+                                                TCP_FLAG_ACK,
+                                                chdev->channel );
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s expect seq_num %x != rcvd %x => ACK and discard\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state),
+CONFIG_SOCK_ISS_CLIENT + 1, seg_seq_num );
+#endif
+                        break;
+                    }
+                }
+                else                   // SEQ_NUM acceptable
                 {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received RST flag\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state) );
-#endif
-                    if( (socket_state == TCP_STATE_ESTAB     ) ||
-                        (socket_state == TCP_STATE_FIN_WAIT1 ) ||
-                        (socket_state == TCP_STATE_FIN_WAIT2 ) ||
-                        (socket_state == TCP_STATE_CLOSE_WAIT) )
+                    // compute number of new bytes & number of duplicated bytes
+                    if( seg_seq_num != socket_rx_nxt )  // duplicate segment
                     {
-                        // TODO all pending send & received commands 
-                        // must receive "reset" responses
-
-                        // TODO destroy the socket
+                        seg_data_dup = socket_rx_nxt - seg_seq_num; 
+                        seg_data_new = (seg_data_len > seg_data_dup) ?
+                                       (seg_data_len - seg_data_dup) : 0;
+                    }
+                    else                                // expected segment
+                    {
+                        seg_data_dup = 0;
+                        seg_data_new = seg_data_len;
+                    }
+                    
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s seq_num %x / rx_nxt %x / len %d / new %d / dup %d\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state), 
+seg_seq_num, socket_rx_nxt, seg_data_len, seg_data_new, seg_data_dup );
+#endif
+                }
+
+                // [2] handle RST flag (depending on socket state)
+                if( seg_rst_set  ) 
+                {
+                    if( socket_state == TCP_STATE_SYN_RCVD )
+                    {
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s RST received from remote TCP => report to user\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                        // report RST to local TX client thread
+                        dev_nic_unblock_tx_client( socket_xp , CMD_STS_RST );
+
+                        // update socket state
+                        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state),
+                                        TCP_STATE_BOUND );
+                        break;
+                    }
+
+                    else if( (socket_state == TCP_STATE_ESTAB     ) ||
+                             (socket_state == TCP_STATE_FIN_WAIT1 ) ||
+                             (socket_state == TCP_STATE_FIN_WAIT2 ) ||
+                             (socket_state == TCP_STATE_CLOSE_WAIT) )
+                    {
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s / received RST flag\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                        // report RST to local TX client thread
+                        if( socket_tx_valid ) dev_nic_unblock_tx_client( socket_xp, 
+                                                                         CMD_STS_RST );
+                        // report RST to local RX client thread
+                        if( socket_rx_valid ) dev_nic_unblock_rx_client( socket_xp, 
+                                                                         CMD_STS_RST );
+                        // update socket state
+                        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state),
+                                        TCP_STATE_BOUND );
+                        break;
                     }
                     else  // states CLOSING / LAST_ACK / TIME_WAIT
                     {
-                        // TODO          
+                        // update socket state
+                        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state),
+                                        TCP_STATE_BOUND );
+                        break;
                     }
+                }
+ 
+                // [3] handle security & precedence TODO ... someday
+
+                // [4] check SYN  
+                if( seg_syn_set )           // received SYN => send RST to remote
+                {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s socket[%x,%d] %s : received SYN flag => send RST-ACK\n",
+__FUNCTION__, pid, fdid , socket_state_str(socket_state) );
+#endif
+                    // send RST & ACK to remote TCP 
+                    socket_put_r2t_request( socket_r2tq_xp,
+                                            TCP_FLAG_RST | TCP_FLAG_ACK,
+                                            chdev->channel );
+
+                    // report RST to local TX client thread
+                    if( socket_tx_valid ) dev_nic_unblock_tx_client( socket_xp, 
+                                                                     CMD_STS_RST );
+                    // report RST to local RX client thread
+                    if( socket_rx_valid ) dev_nic_unblock_rx_client( socket_xp, 
+                                                                     CMD_STS_RST );
+                    // update socket state
+                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state), 
+                                    TCP_STATE_BOUND );
                     break;
                 }
 
-                // [3] handle security & precedence TODO ... someday
-
-                // [4] check SYN flag 
-                if( seg_syn_set )                                // received SYN => ERROR
+                // [5] handle ACK (depending on socket state)
+                if( seg_ack_set == false )           // missing ACK => discard segment
                 {
 
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received unexpected SYN\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
-#endif
-                    // TODO signal error to user
-
-                    // make an RST request to R2T queue 
-                    socket_put_r2t_request( socket_r2tq_xp, 
-                                            TCP_FLAG_RST,
-                                            chdev->channel );
-
-                    // update socket state
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state), TCP_STATE_BOUND );
-
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s / no ACK in segment => discard\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
                     break;
                 }
 
-                // [5] check ACK  
-                if( seg_ack_set == false )                           // missing ACK
+                // compute acceptable ACK
+                bool_t ack_ok = is_in_window( seg_ack_num,
+                                              socket_tx_una,
+                                              socket_tx_nxt );
+
+                if( socket_state == TCP_STATE_SYN_RCVD )
                 {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : no ACK flag\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state) );
-#endif
-                    // discard segment
-                    break;
-                }
-                else if( is_in_window( seg_ack_num,
-                                       socket_tx_una,
-                                       socket_tx_nxt ) == false )    // unacceptable ACK
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : ACK_NUM %x not in [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state),
-seg_ack_num, socket_tx_una, socket_tx_nxt );
-#endif
-                    // discard segment
-                    break;
-                }
-                else                                                // acceptable ack
-                {
-                    // update socket.tx_una
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_una), seg_ack_num );
-
-                    // update socket.tx_wnd  
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_wnd), seg_window );
-
-                    // check last data byte acknowledged for a SEND command
-                    if( (socket_tx_todo == 0) && 
-                        (seg_ack_num == socket_tx_nxt) &&
-                        (socket_tx_cmd == CMD_TX_SEND) )
+                    if( ack_ok )                      //  acceptable ACK
                     {
-                        // signal success to TX client thread
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : received expected ACK => update socket\n",
+__FUNCTION__, pid, fdid , socket_state_str(socket_state) );
+#endif
+                        // set socket.tx_una  
+                        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_una), seg_ack_num );
+
+                        // update socket.state
+                        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state), 
+                                        TCP_STATE_ESTAB );
+
+                        // report success to local TX client thread
                         dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
                     }
+                    else                               // send RST to remote
+                    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s / ACK %x not in [%x,%x] => discard\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state),
+seg_ack_num, socket_tx_una, socket_tx_nxt );
+#endif
+                        // send RST & ACK to remote TCP 
+                        socket_put_r2t_request( socket_r2tq_xp,
+                                                TCP_FLAG_RST | TCP_FLAG_ACK,
+                                                chdev->channel );
+                        break;
+                    }
                 }
-                    
-                // [7] handle URG flag  TODO ... someday
-
-                // [8] Move DATA to rx_buf / ACK request to R2T queue / unblock rx_client
-                if( seg_data_len )
+
+                else if( (socket_state == TCP_STATE_ESTAB)      ||
+                         (socket_state == TCP_STATE_FIN_WAIT1)  ||
+                         (socket_state == TCP_STATE_FIN_WAIT2)  ||
+                         (socket_state == TCP_STATE_FIN_WAIT2)  ||
+                         (socket_state == TCP_STATE_CLOSE_WAIT) ||
+                         (socket_state == TCP_STATE_CLOSING)    )
                 {
-                    if( (socket_state == TCP_STATE_ESTAB)     ||
-                        (socket_state == TCP_STATE_FIN_WAIT1) ||
-                        (socket_state == TCP_STATE_FIN_WAIT2) )
+                    if( ack_ok )                      // acceptable ack
+                    {
+                        // compute number of acknowledged bytes 
+                        uint32_t ack_bytes =  seg_ack_num - socket_tx_una;
+
+                        if( ack_bytes )  // handle acknowledged bytes
+                        { 
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %d bytes acknowledged => update socket\n",
+__FUNCTION__, pid, fdid, ack_bytes );
+#endif
+                            // update socket.tx_una, socket.tx_ack, and socket.tx_wnd fields
+                            hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_una),
+                                            seg_ack_num );
+                            hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_ack),
+                                            socket_tx_ack + ack_bytes );
+                            hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_wnd),
+                                            seg_window );
+
+                            //  unblock the TX client thread if last byte acknowledged
+                            if( (socket_tx_ack + ack_bytes) == socket_tx_len )
+                            {
+                                // report success to TX client thread
+                                dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : last ack => unblock TX client thread\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                            }
+                        }
+
+                        if( socket_state == TCP_STATE_FIN_WAIT1 )
+                        {
+                            // update socket state
+                            hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state),
+                                            TCP_STATE_FIN_WAIT2 );
+                        }
+                        if( socket_state == TCP_STATE_FIN_WAIT2 )
+                        {
+                            // TODO
+                        }
+                        else if( socket_state == TCP_STATE_CLOSING )
+                        {
+                            // update socket state
+                            hal_remote_s32( XPTR(socket_cxy , &socket_ptr->state),
+                                            TCP_STATE_TIME_WAIT );
+                        }
+                        else if( socket_state == TCP_STATE_CLOSING )
+                        {
+                            // TODO
+                        }
+                    }
+                    else                    // unacceptable ACK => discard segment
+                    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s / ACK %x not in [%x,%x] => discard\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state),
+seg_ack_num, socket_tx_una, socket_tx_nxt );
+#endif
+                        break;
+                    }
+                }
+    
+                else if( socket_state == TCP_STATE_LAST_ACK )
+                {
+                    // TODO
+                }
+
+                else if( socket_state == TCP_STATE_TIME_WAIT )
+                {
+                    // TODO
+                }
+
+                // [6] handle URG flag  TODO ... someday
+
+                // [7] handle received data : update socket state,
+                // move data to rx_buf, register ACK request to R2T queue,
+                // unblock the RX client thread in case of pending RX_RECV command
+                if((socket_state == TCP_STATE_ESTAB)     ||
+                   (socket_state == TCP_STATE_FIN_WAIT1) ||
+                   (socket_state == TCP_STATE_FIN_WAIT2) )
+                {
+                    // register new bytes if requested 
+                    if( seg_data_new )
                     {
                         // get number of bytes already stored in rx_buf
                         uint32_t status = remote_buf_status( socket_rx_buf_xp );
 
-                        // compute empty space in rx_buf
-                        uint32_t space = CONFIG_SOCK_RX_BUF_SIZE - status;
-
-                        // compute number of bytes to move : min (space , seg_data_len)
-                        uint32_t nbytes = ( space < seg_data_len ) ? space : seg_data_len;
-
-                        // move payload from k_buf to rx_buf
+                        // compute space in rx_buf and actual number of acceptable bytes
+                        // when (space < seg_data_new) the last new bytes are discarded
+                        uint32_t space = (1 << CONFIG_SOCK_RX_BUF_ORDER) - status;
+                        uint32_t rcv_bytes = (space < seg_data_new) ? space : seg_data_new;
+
+                        // move new bytes from k_buf to rx_buf
                         remote_buf_put_from_kernel( socket_rx_buf_xp, 
-                                                    k_buf + seg_hlen,
-                                                    nbytes );
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : move %d bytes to rx_buf\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state), nbytes );
-#endif
-                        // update socket.rx_nxt 
+                                                    k_buf + seg_hlen + seg_data_dup,
+                                                    rcv_bytes );
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : move %d bytes to rx_buf\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state), rcv_bytes );
+ #endif
+                        // update socket.rx_nxt and socket_rx_wnd fields
                         hal_remote_s32( XPTR( socket_cxy , &socket_ptr->rx_nxt ),
-                                              socket_rx_nxt + nbytes );
-
-                        // update socket.rx_wnd 
+                                        socket_rx_nxt + rcv_bytes );
                         hal_remote_s32( XPTR( socket_cxy , &socket_ptr->rx_wnd ),
-                                              socket_rx_wnd - nbytes ); 
-
-                        // make an ACK request to R2T queue 
+                                        socket_rx_wnd - rcv_bytes ); 
+
+                        // unblock RX client if required
+                        if( (socket_rx_valid == true) && (socket_rx_cmd == CMD_RX_RECV) )
+                        {
+                            // reset rx_valid
+                            hal_remote_s32( XPTR(socket_cxy,&socket_ptr->rx_valid), false );
+
+                            // report success to RX client thread
+                            dev_nic_unblock_rx_client( socket_xp , CMD_STS_SUCCESS );
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : last data => unblock RX client thread\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                        }
+                    }
+
+                    // make an ACK request to remote 
+                    socket_put_r2t_request( socket_r2tq_xp,
+                                            TCP_FLAG_ACK,
+                                            chdev->channel );
+                }  // end payload handling
+
+                // [8] handle FIN flag depending on socket state
+                if( (socket_state == TCP_STATE_SYN_RCVD) ||
+                    (socket_state == TCP_STATE_ESTAB )   )
+                {
+                    if( seg_fin_set )      
+                    {
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : FIN-ACK => goes CLOSE_WAIT\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                        // update socket.rx_nxt when FIN received
+                        hal_remote_s32( XPTR( socket_cxy , &socket_ptr->rx_nxt ),
+                                        socket_rx_nxt + 1 ); 
+
+                        // update socket state
+                        hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ),
+                                        TCP_STATE_CLOSE_WAIT );
+
+                        // send ACK to remote TCP
                         socket_put_r2t_request( socket_r2tq_xp,
                                                 TCP_FLAG_ACK,
@@ -1294,58 +1514,15 @@
 
                         // check pending RX_RECV command
-                        if( (socket_rx_valid == true) &&
-                            (socket_rx_cmd == CMD_RX_RECV) )
+                        if( (socket_rx_valid == true) && (socket_rx_cmd == CMD_RX_RECV) )
                         {
                             // reset rx_valid
                             hal_remote_s32( XPTR(socket_cxy,&socket_ptr->rx_valid), false );
 
-                            // report success to RX client thread
-                            dev_nic_unblock_rx_client( socket_xp , CMD_STS_SUCCESS );
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : unblock waiting RX client thread\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state) );
-#endif
-                        }
-                    }
-                }
-
-                // [9] handle FIN flag 
-                if( socket_state == TCP_STATE_ESTAB )
-                {
-                    if( seg_fin_set )  // received ACK & FIN    
-                    {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : FIN-ACK => goes CLOSE_WAIT\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state) );
-#endif
-                        // update socket.rx_nxt when FIN received
-                        hal_remote_s32( XPTR( socket_cxy , &socket_ptr->rx_nxt ),
-                                        socket_rx_nxt + 1 ); 
-
-                        // update socket state
-                        hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ),
-                                        TCP_STATE_CLOSE_WAIT );
-
-                        // make an ACK request to R2T queue
-                        socket_put_r2t_request( socket_r2tq_xp,
-                                                TCP_FLAG_ACK,
-                                                chdev->channel );
-
-                        // check pending RX_RECV command
-                        if( (socket_rx_valid == true) &&
-                            (socket_rx_cmd == CMD_RX_RECV) )
-                        {
-                            // reset rx_valid
-                            hal_remote_s32( XPTR(socket_cxy,&socket_ptr->rx_valid), false );
-
-                            // report error to RX client thread
+                            // report FIN to RX client thread
                             dev_nic_unblock_rx_client( socket_xp , CMD_STS_EOF );
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : unblock RX client waiting on RECV\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state) );
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : unblock RX client waiting on RECV\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
 #endif
                         } 
